class SpeechBalloon < ActiveRecord::Base
  has_many :balloons, :dependent => :destroy
  has_many :speeches, :dependent => :destroy
  belongs_to :speech_balloon_template
  belongs_to :panel
  
  accepts_nested_attributes_for :balloons
  accepts_nested_attributes_for :speeches
  
  validates :panel_id, :numericality => {:allow_blank => true}
  validates :speech_balloon_template_id, :presence => true, :numericality => true, :existence => true
  validates :classname, :presence => true, :length => {:maximum => 50}
  validates :z, :presence => true, :numericality => {:greater_than => 0}
  validates :t, :presence => true, :numericality => {:greater_than_or_equal_to => 0}
#  validates :settings, :presence => true
  
end
