#フキダシテンプレート
class SpeechBalloonTemplate < ActiveRecord::Base
  has_many :speech_balloons
  
  validates :name, :presence => true, :uniqueness => true, :length => {:maximum => 50}
  validates :classname, :presence => true, :length => {:maximum => 50}
  validates :caption, :presence => true, :length => {:maximum => 30}
  validates :t, :presence => true, :numericality => {:greater_than_or_equal_to => 0}
  validates :settings, :presence => true
  
  def supply_default
  end
  
  def overwrite
    self.t = SpeechBalloonTemplate.count.to_i if self.new_record?
  end
  
  def visible? author
    true
  end
  
  def self.list
    opt = {}
    opt.merge!(self.list_opt)
    opt.merge!({:order => 'speech_balloon_templates.t asc'})
    SpeechBalloonTemplate.find(:all, opt)
  end
  
  def self.list_opt
    {}
  end
  
  def self.list_json_opt
    {}
  end
  
  def self.show rid, au
    opt = {}
    opt.merge!(self.show_opt)
    res = SpeechBalloonTemplate.find(rid, opt)
    raise ActiveRecord::Forbidden unless res.visible?(au)
    res
  end
  
  def self.show_opt
    {}
  end
  
  def self.show_json_opt
    {}
  end
  
  def self.store name, attr
    #settingsにはHashデータが丸っと文字列化されて入る
    r = SpeechBalloonTemplate.replace_system_picture(attr["settings"] || {})
    attr["settings"] = r ? r.to_json : nil
    r = SpeechBalloonTemplate.modify_object name, attr
    r.overwrite
    r.save
    r
  end
  
  def self.import filename
    SpeechBalloonTemplate.import_file(filename) {|name, attr| SpeechBalloonTemplate.store(name, attr)}
  end
  
end
